package com.ruoyi.gysl.controller;


import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.gysl.entity.ProjectRemark;
import com.ruoyi.gysl.entity.request.RemarkPageReq;
import com.ruoyi.gysl.service.BasicInformationService;
import com.ruoyi.gysl.service.ProjectRemarkService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import javax.validation.Valid;
import java.io.Serializable;
import java.util.List;

/**
 * 项目备忘录(ProjectRemark)表控制层
 *
 * @author makejava
 * @since 2025-03-19 10:49:35
 */
@Api(tags = "项目备忘录")
@RestController
@RequestMapping("/gysl/projectRemark")
public class ProjectRemarkController extends BaseController {
    /**
     * 服务对象
     */
    @Resource
    private ProjectRemarkService projectRemarkService;

    /**
     * 基本信息
     */
    @Resource
    private BasicInformationService basicInformationService;
    /**
     * 查询所有数据
     *
     * @param projectRemark 查询实体
     * @return 所有数据
     */
    @ApiOperation("查询所有数据")
    @GetMapping("/page")
    public AjaxResult selectAll(@Valid RemarkPageReq projectRemark) {
        basicInformationService.testXmId(projectRemark.getXmId());
        return success(projectRemarkService.list(projectRemark));
    }

    /**
     * 通过主键查询单条数据
     *
     * @param id 主键
     * @return 单条数据
     */
    @GetMapping("/{id}")
    @ApiOperation(value = "通过主键查询单条数据",response = ProjectRemark.class )
    public AjaxResult selectOne(@PathVariable Serializable id) {
        ProjectRemark byId = projectRemarkService.getById(id);
        basicInformationService.testXmId(byId.getXmId());
        return success(byId);
    }
    /**
     * 新增数据
     *
     * @param projectRemark 实体对象
     * @return 新增结果
     */
    @ApiOperation("新增数据")
    @PostMapping("/add")
    public AjaxResult insert(@RequestBody ProjectRemark projectRemark) {
        return success(projectRemarkService.save(projectRemark));
    }

    /**
     * 修改数据
     *
     * @param projectRemark 实体对象
     * @return 修改结果
     */
    @ApiOperation("修改数据")
    @PutMapping("/edit")
    public AjaxResult update(@RequestBody ProjectRemark projectRemark) {
        basicInformationService.testXmId(projectRemark.getXmId());
        return success(projectRemarkService.updateById(projectRemark));
    }

    /**
     * 删除数据
     *
     * @param idList 主键结合
     * @return 删除结果
     */
    @ApiOperation("删除数据")
    @DeleteMapping("/delete")
    public AjaxResult delete(@RequestParam("idList") List<Long> idList) {
        return success(projectRemarkService.removeByIds(idList));
    }
}

